<?php
require_once($_SERVER["DOCUMENT_ROOT"]."/lgwebapp.inc");
require_once($path_common."/sitepage.inc");
require_once($path_common."/module.inc");

class LauncherPage extends SitePage
{
   public function __construct()
   {
      parent::__construct();
   }

   public function get_css_linked()
   {
      return array
      (
         "sitewide.css",
         "launcher.css"
      );
   }

   public function set_css_id()
   {
      $this->css_id = "launcher";
   }

   public function get_header()
   {
      return "";
   }

   public function get_footer()
   {
      return "";
   }

   public function get_content()
   {
      $mod = new LauncherIntro($this);
      $intro = $mod->create();

      $mod = new LauncherDemos($this);
      $demos = $mod->create();

      return <<<EOD
$intro
$demos

EOD;
   }
}

class LauncherIntro extends Module
{
   public function __construct($page)
   {
      parent::__construct($page);
   }

   public function get_css()
   {
      global $path_img;

      return <<<EOD
#lchint
{
   background: url({$path_img}/dlwa_cover.gif) top left no-repeat;
}

EOD;
   }

   public function get_content()
   {
      global $path_img;

      return <<<EOD
<div id="lchint">
   <div class="ident">
      <h1>
         <a href="http://www.oreilly.com/catalog/9780596803025">
            Developing Large Web Applications
         </a>
      </h1>
      <h2>
         <a href="http://www.oreilly.com/catalog/9780596803025">
            Producing Code That Can Grow and Thrive
         </a>
      </h2>
      <cite>
         <a href="http://www.oreillynet.com/pub/au/675">
            By Kyle Loudon<br />
            Publisher: O'Reilly Media<br />
            Released: March 2010
         </a>
      </cite>
   </div>
</div>

EOD;
   }
}

class LauncherDemos extends Module
{
   protected $demos;

   public function __construct($page)
   {
      parent::__construct($page);
   }

   public function get_content()
   {
      $demos = $this->get_demos();
      
      return <<<EOD
<div id="lchdem">
$demos
</div>

EOD;
   }

   protected function get_demos()
   {
      global $path_base;

      return <<<EOD
   <div class="demo">
      <h3>
         <a href="{$path_base}/laydemos/index.html?type=layres">Results Layout</a>
      </h3>
      <p>
         Location: <code>.../lgwebapp/laydemos</code>
      </p>
      <p>
         Includes the following examples from the book to demonstrate the Results layout:
      </p>
      <ul class="examples">
         <li>
            Example 4-17
         </li>
         <li>
            Example 4-18
         </li>
         <li>
            Example 7-3
         </li>
         <li>
            Example 7-4
         </li>
         <li>
            Example 7-5
         </li>
         <li>
            Example 7-9
         </li>
         <li>
            Example 7-10
         </li>
      </ul>
   </div>
   <div class="demo">
      <h3>
         <a href="{$path_base}/laydemos/index.html?type=laydtl">Details Layout</a>
      </h3>
      <p>
         Location: <code>.../lgwebapp/laydemos</code>
      </p>
      <p>
         Includes the following examples from the book to demonstrate the Details layout:
      </p>
      <ul class="examples">
         <li>
            Example 4-19
         </li>
         <li>
            Example 4-20
         </li>
         <li>
            Example 7-3
         </li>
         <li>
            Example 7-4
         </li>
         <li>
            Example 7-5
         </li>
         <li>
            Example 7-9
         </li>
      </ul>
   </div>
   <div class="demo">
      <h3>
         <a href="{$path_base}/multisel/index.html">MultiSelect</a>
      </h3>
      <p>
         Location: <code>.../lgwebapp/multisel</code>
      </p>
      <p>
         Includes the following examples from the book to implement chained selections:
      </p>
      <ul class="examples">
         <li>
            Example 5-8
         </li>
         <li>
            Example 5-9
         </li>
         <li>
            Example 5-10
         </li>
         <li>
            Example 5-11
         </li>
         <li>
            Example 5-12
         </li>
         <li>
            Example 8-11
         </li>
         <li>
            Example 8-12
         </li>
         <li>
            Example 8-13
         </li>
      </ul>
   </div>
   <div class="demo">
      <h3>
         <a href="{$path_base}/slideshow/index.html">Slideshow</a>
      </h3>
      <p>
         Location: <code>.../lgwebapp/slideshow</code>
      </p>
      <p>
         Includes the following examples from the book to implement a sample slideshow:
      </p>
      <ul class="examples">
         <li>
            Example 7-3
         </li>
         <li>
            Example 7-4
         </li>
         <li>
            Example 7-5
         </li>
         <li>
            Example 7-6
         </li>
         <li>
            Example 7-7
         </li>
         <li>
            Example 7-8
         </li>
      </ul>
   </div>
   <div class="demo">
      <h3>
         <a href="{$path_base}/mvcpanel/index.html">MVC with Ajax</a>
      </h3>
      <p>
         Location: <code>.../lgwebapp/mvcpanel</code>
      </p>
      <p>
         Includes the following examples from the book to demonstrate MVC with Ajax:
      </p>
      <ul class="examples">
         <li>
            Example 8-8
         </li>
         <li>
            Example 8-9
         </li>
         <li>
            Example 8-10
         </li>
         <li>
            Example 8-11
         </li>
         <li>
            Example 8-13
         </li>
      </ul>
   </div>

EOD;
   }
}
?>
