<?php
require_once($_SERVER["DOCUMENT_ROOT"]."/lgwebapp.inc");
require_once($path_common."/sitepage.inc");
require_once($path_common."/module.inc");

class MVCPanelPage extends SitePage
{
   public function __construct()
   {
      parent::__construct();
   }

   public function get_css_linked()
   {
      return array
      (
         "sitewide.css",
         "mvcpanel.css"
      );
   }

   public function get_header()
   {
      return "";
   }

   public function get_footer()
   {
      return "";
   }

   public function get_content()
   {
      $mod = new MVCPanel($this);
      $mvcpanel = $mod->create();

      return <<<EOD
$mvcpanel

EOD;
   }
}

class MVCPanel extends Module
{
   public function __construct($page)
   {
      parent::__construct($page);
   }

   public function get_js_linked()
   {
      return array
      (
         "yahoo-dom-event.js",
         "json_parse.js",
         "connection.js",
         "model-view-cont.js"
      );
   }

   public function get_js()
   {
      global $path_ajax;

      return <<<EOD
TestModel = function()
{
   MVC.Model.call(this);
};

// TestModel objects are derived from the Model object.
TestModel.prototype = new MVC.Model();

TestModel.prototype.init = function()
{
   // The state member of a model stores the current data for the model. 
   this.state =
   {
      message: "Initial message"
   };

   // Only the setState method does notifications automatically for you. 
   this.notify();
};

TestModel.prototype.abandon = function()
{
   // Implement this method to do whatever is needed to handle timeouts.
   alert("Called abandon to handle communications timeout.");
};

TestModel.prototype.recover = function()
{
   // Implement this method to do whatever is needed to handle timeouts.
   alert("Called recover to handle communications failure.");
};

TestView = function()
{
   MVC.View.call(this);
};

// TestView objects are derived from the View object.
TestView.prototype = new MVC.View();

TestView.prototype.update = function()
{
   // The id member is the containing element for the view in the DOM.
   var element = document.getElementById(this.id);

   // Whenever a view updates itself, it needs the state of its model.
   msg = this.model.getState().message;

   // Do the actual update for keeping this view current with the model.
   element.innerHTML = msg;
};

// This is the model that will keep track of the time last retrieved.
var model = new TestModel();

// Set a short connection timeout just to speed up the testing case.
model.setTimeout(2000);

// Create each view and attach the model. Attaching subscribes the view.
var view1 = new TestView();
view1.attach(model, "testview1");

var view2 = new TestView();
view2.attach(model, "testview2");

// This method handles the various actions by which you change the model.
function handleAction(mode)
{
   switch (mode)
   {
      case "loc":
         // Create a local timestamp without performing an Ajax request.
         var d = new Date();
         var h = ((h = d.getHours()) < 10) ? "0" + h : h;
         var m = ((m = d.getMinutes()) < 10) ? "0" + m : m;
         var s = ((s = d.getSeconds()) < 10) ? "0" + s : s;
         var t = h + ":" + m + ":" + s;

         // Update the model locally with the timestamp from the browser.
         model.setState({message: "Hello from the browser at " + t});
         break;

      case "rmt":
         // Update the model with a remote timestamp via an Ajax request.
         model.setState("GET", "{$path_ajax}/mvcpanel/ajaxtest.php");
         break;

      case "bad":
         // Simulate a failure by giving an invalid URL for the request.
         model.setState("GET", "xxxxxxxx.php");
         break;

      case "dat":
      case "tmo":
         // Pass the mode to the server to test data or timeout problems.
         model.setState("GET", "{$path_ajax}/mvcpanel/ajaxtest.php?mode="+mode);
         break;

      case "abt":
         // Tell the model to abort the current request if still running.
         model.abort();
         break;

      case "pol":
         // Toggle the policy for how to handle Ajax request collisions.
         if (model.collpol == MVC.Connect.Ignore)
         {
            model.setCollisionPolicy(MVC.Connect.Change);
            alert("Collision policy has been toggled to \"Change\".");
         }
         else
         {
            model.setCollisionPolicy(MVC.Connect.Ignore);
            alert("Collision policy has been toggled to \"Ignore\".");
         }

         break;
   }
}

// Initialize the model to a start value, which notifies the views too.
model.init();

EOD;
   }

   public function get_content()
   {
      return <<<EOD
<div id="mvcpnl">
   <div id="testview1">
   </div>
   <div id="actions">
      <input id="loc" type="button" value="Local" onclick=
         "handleAction('loc');" />
      <input id="rmt" type="button" value="Remote" onclick=
         "handleAction('rmt');" />
      <input id="bad" type="button" value="Fail" onclick=
         "handleAction('bad');" />
      <input id="dat" type="button" value="Data" onclick=
         "handleAction('dat');" />
      <input id="tmo" type="button" value="Timeout" onclick=
         "handleAction('tmo');" />
      <input id="abt" type="button" value="Abort" onclick=
         "handleAction('abt');" />
      <input id="pol" type="button" value="Policy" onclick=
         "handleAction('pol');" />
   </div>
   <div id="testview2">
   </div>
</div>

EOD;
   }
}
?>
